> For the complete documentation index, see [llms.txt](https://docs.coldstack.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.coldstack.io/http-api-compatible-with-amazon-s3/api-reference.md).

# API Reference

The ColdStack HTTP API provides the following services:

| Service                                                                                           | Description                        |
| ------------------------------------------------------------------------------------------------- | ---------------------------------- |
| [Bucket](/http-api-compatible-with-amazon-s3/api-reference.md#bucket-service)                     | Manages buckets.                   |
| [Object](/http-api-compatible-with-amazon-s3/api-reference.md#object-service)                     | Manages objects.                   |
| [Multipart upload](/http-api-compatible-with-amazon-s3/api-reference.md#multipart-upload-service) | Controls loading of large objects. |

### Supported Operations <a href="#operations-list" id="operations-list"></a>

#### Bucket service <a href="#bucket-service" id="bucket-service"></a>

| Method                                                                                               | Description                                            |
| ---------------------------------------------------------------------------------------------------- | ------------------------------------------------------ |
| [HeadBucket](/http-api-compatible-with-amazon-s3/api-reference/bucket/getmeta.md)                    | Checks for the existence of a bucket and access to it. |
| [ListObjects/ListObjectsV2](/http-api-compatible-with-amazon-s3/api-reference/bucket/listobjects.md) | Returns a list of objects in a bucket.                 |
| [ListBuckets](/http-api-compatible-with-amazon-s3/api-reference/bucket/listbuckets.md)               | Returns a list of buckets.                             |
| [RenameBucket](/http-api-compatible-with-amazon-s3/api-reference/bucket/renamebucket.md)             | Changes bucket's name.                                 |

#### Object service <a href="#object-service" id="object-service"></a>

| Method                                                                                   | Description                                |
| ---------------------------------------------------------------------------------------- | ------------------------------------------ |
| [PutObject](/http-api-compatible-with-amazon-s3/api-reference/object/upload.md)          | Loads an object into Object Storage.       |
| [GetObject](/http-api-compatible-with-amazon-s3/api-reference/object/get.md)             | Unloads an object from Object Storage.     |
| [HeadObject](/http-api-compatible-with-amazon-s3/api-reference/object/getobjectmeta.md)  | Unloads the object's metadata.             |
| [RenameObject](/http-api-compatible-with-amazon-s3/api-reference/object/renameobject.md) | Changes object's key (renames the object). |

#### Multipart upload service <a href="#multipart-upload-service" id="multipart-upload-service"></a>

| Method                                                                                                          | Description                   |
| --------------------------------------------------------------------------------------------------------------- | ----------------------------- |
| [CreateMultipartUpload](/http-api-compatible-with-amazon-s3/api-reference/multipart-upload/startupload.md)      | Initializes a composite load. |
| [UploadPart](/http-api-compatible-with-amazon-s3/api-reference/multipart-upload/uploadpart.md)                  | Loads part of an object.      |
| [CompleteMultipartUpload](/http-api-compatible-with-amazon-s3/api-reference/multipart-upload/completeupload.md) | Ends a multipart load.        |

### see also <a href="#see-also" id="see-also"></a>

* [How to use the API](/http-api-compatible-with-amazon-s3/how-to-use-the-api.md)
* [Supported tools](/tools/supported-tools.md)


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.coldstack.io/http-api-compatible-with-amazon-s3/api-reference.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
